Lattice Grid Buy a licence

demo D11

Reorder by drag

Moving columns, constrained to their group and pinned region

columns.move(id, index)

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  // Drag a heading to move its column. A pinned column stays in its pinned lane.
  const columns = [
    { field: 'service', title: 'Service', layout: { pin: 'start', width: 140 } },
    { field: 'team', title: 'Team' },
    { field: 'region', title: 'Region' },
    { field: 'tier', title: 'Tier' },
    { field: 'instances', title: 'Instances', type: 'number' },
    { field: 'monthlyCost', title: 'Monthly cost', type: 'number', format: { style: 'currency', currency: 'USD' } },
  ];

  const rows = [/* 5,000 service records */];

  function App() {
    return (
      <LatticeGrid
        rowKey="id"
        columns={columns}
        rows={rows}
        style={{ height: '540px' }}
      />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>

Drag-to-reorder columns within groups and pinned regions

columns.move(id, index) moves a column to a new position, and the same operation drives what happens when a user drags a header. A developer reaches for column reordering once a grid ships with more than a handful of fields, because the order that made sense at build time rarely matches the order an individual user wants to scan every day, and a JavaScript data grid that locks that order in place pushes the workaround onto whoever built the report. The constraint that matters in practice is scope: a column dragged mid-drag cannot leave its column group, and a frozen column in a pinned region cannot be dragged out into the scrollable body, so reordering never produces a layout the grid cannot render correctly. columns.move respects those same boundaries when called programmatically, so a saved layout restored from storage cannot smuggle a pinned column into the wrong region either. The drag itself tracks pointer position against header boundaries rather than column width, so reordering stays accurate whether columns are five characters wide or fifty. Keyboard users get the same operation without a pointer: moving focus to a header and issuing the move command reorders it in place, so column order is never a mouse-only feature.

How do I let users reorder columns by dragging in a data grid?

Enable drag handles on the header and the grid calls columns.move(id, index) internally as the user drops a column in its new position. The move is constrained to the column’s own group and pinned region, so a drag cannot separate a column from its group or pull it across a frozen boundary. Call columns.move directly to reorder programmatically, such as when restoring a saved layout.

Lattice Grid Buy a licence

demo D11

Reorder by drag

Moving columns, constrained to their group and pinned region

columns.move(id, index)

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

// Drag a heading to move its column. A pinned column stays in its pinned lane.
const columns = [
  { field: 'service', title: 'Service', layout: { pin: 'start', width: 140 } },
  { field: 'team', title: 'Team' },
  { field: 'region', title: 'Region' },
  { field: 'tier', title: 'Tier' },
  { field: 'instances', title: 'Instances', type: 'number' },
  { field: 'monthlyCost', title: 'Monthly cost', type: 'number', format: { style: 'currency', currency: 'USD' } },
];

const rows = [/* 5,000 service records */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    rowKey: 'id',
    columns: columns,
    rows: rows,
  };
}

bootstrapApplication(AppComponent);

Drag-to-reorder columns within groups and pinned regions

columns.move(id, index) moves a column to a new position, and the same operation drives what happens when a user drags a header. A developer reaches for column reordering once a grid ships with more than a handful of fields, because the order that made sense at build time rarely matches the order an individual user wants to scan every day, and a JavaScript data grid that locks that order in place pushes the workaround onto whoever built the report. The constraint that matters in practice is scope: a column dragged mid-drag cannot leave its column group, and a frozen column in a pinned region cannot be dragged out into the scrollable body, so reordering never produces a layout the grid cannot render correctly. columns.move respects those same boundaries when called programmatically, so a saved layout restored from storage cannot smuggle a pinned column into the wrong region either. The drag itself tracks pointer position against header boundaries rather than column width, so reordering stays accurate whether columns are five characters wide or fifty. Keyboard users get the same operation without a pointer: moving focus to a header and issuing the move command reorders it in place, so column order is never a mouse-only feature.

How do I let users reorder columns by dragging in a data grid?

Enable drag handles on the header and the grid calls columns.move(id, index) internally as the user drops a column in its new position. The move is constrained to the column’s own group and pinned region, so a drag cannot separate a column from its group or pull it across a frozen boundary. Call columns.move directly to reorder programmatically, such as when restoring a saved layout.